/* Sistemas Integrados TECNISA
   Servios

Nome: ATUSALDO_EMPPED

Descrio:
   Atualiza o saldo do empenho quando o pedido  alterado
Criao:
31/01/07 - Welbert G. Moitinha
@c:\web_605\sql\end_conv\oracle\2805_PEDTRGO_ATUSALDO_EMPPED.SQL
*/


CREATE OR REPLACE TRIGGER ATUSALDO_EMPPED
BEFORE INSERT OR UPDATE OR DELETE
ON PEDIDO FOR EACH ROW
DECLARE
   V_IDTABPRECO   VARCHAR2(1);
   V_IDUTCTRELANP VARCHAR2(1);
   V_IDUTCTREMPEN VARCHAR2(1);
   V_IDSITPEDIDO  VARCHAR2(1);
   V_SALDOGERAL   FLOAT;
   V_VRPEDIDO     FLOAT;
BEGIN
   V_IDTABPRECO   := '';
   V_IDUTCTRELANP := '';
   V_IDUTCTREMPEN := '';
   V_SALDOGERAL   := 0;
   V_VRPEDIDO     := 0;

   BEGIN
      SELECT P.IDTABPRECO, P.IDUTCTRELANP, PR.IDUTCTREMPEN
        INTO V_IDTABPRECO, V_IDUTCTRELANP, V_IDUTCTREMPEN
        FROM PARAMPEDIDO P, PARAMGERAL PR
       WHERE P.CDFILIAL = :NEW.CDFILIAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_IDTABPRECO   := '';
         V_IDUTCTRELANP := '';
         V_IDUTCTREMPEN := '';
   END;

   IF (V_IDTABPRECO = '1') AND (V_IDUTCTREMPEN = 'S') AND (:NEW.IDTIPOPEDIDO = '1') THEN
      IF (UPDATING) AND (NVL(:OLD.NREMPENHO, 'M') <> NVL(:NEW.NREMPENHO, 'M')) 
         AND (V_IDUTCTRELANP = '2') THEN

         SELECT SUM (QTITEMPED* VRPREUNITPED - NVL(VRDESITPED,0))
           INTO V_VRPEDIDO
           FROM ITEMPEDIDO
          WHERE :NEW.CDFILIAL = CDFILIAL
            AND :NEW.NRPEDIDO = NRPEDIDO;
/*PASSA O VALOR DO PEDIDO PARA O EMPENHO ANTERIOR*/
         IF :OLD.NREMPENHO >= '0' THEN
           UPDATE EMPENHO
              SET VRSALDOEMP = (V_VRPEDIDO + VRSALDOEMP)
            WHERE CDCLIENTE = :NEW.CDCLIENTE
              AND NREMPENHO = :OLD.NREMPENHO;
         END IF;

         IF :NEW.NREMPENHO >= '0' THEN 
           SELECT VRSALDOEMP
             INTO V_SALDOGERAL
             FROM EMPENHO
            WHERE CDCLIENTE = :NEW.CDCLIENTE
              AND NREMPENHO = :NEW.NREMPENHO;
                  
/* ABATE O VALOR DO PEDIDO NO NOVO EMPENHO */
           IF (V_SALDOGERAL >0) AND (V_SALDOGERAL >= V_VRPEDIDO) THEN
              UPDATE EMPENHO
                 SET VRSALDOEMP = (VRSALDOEMP - V_VRPEDIDO)
               WHERE CDCLIENTE = :NEW.CDCLIENTE
                 AND NREMPENHO = :NEW.NREMPENHO;
           ELSE
              raise_application_error(-20501, 'SALDO_INSU', True);
           END IF;
         END IF;
      ELSE
         IF (UPDATING) AND (:NEW.NREMPENHO IS NOT NULL) /*AND ((:NEW.IDSITPEDIDO <> :OLD.IDSITPEDIDO))*/ THEN

            SELECT SUM(QTITEMPED * VRPREUNITPED - NVL(VRDESITPED,0))
              INTO V_VRPEDIDO
              FROM ITEMPEDIDO
             WHERE :NEW.CDFILIAL = CDFILIAL
               AND :NEW.NRPEDIDO = NRPEDIDO;

            IF (:NEW.IDSITPEDIDO = '4') THEN
               UPDATE EMPENHO
                  SET VRSALDOEMP = (V_VRPEDIDO + VRSALDOEMP)
                WHERE CDCLIENTE = :NEW.CDCLIENTE
                  AND NREMPENHO = :NEW.NREMPENHO;
            ELSE
               IF (:NEW.IDSITPEDIDO IN ('1', '2')) THEN
                  SELECT VRSALDOEMP
                    INTO V_SALDOGERAL
                    FROM EMPENHO
                   WHERE CDCLIENTE = :NEW.CDCLIENTE
                     AND NREMPENHO = :NEW.NREMPENHO;


                  IF (V_SALDOGERAL >= V_VRPEDIDO) THEN
                     UPDATE EMPENHO
                        SET VRSALDOEMP = (VRSALDOEMP - V_VRPEDIDO)
                      WHERE CDCLIENTE = :NEW.CDCLIENTE
                        AND NREMPENHO = :NEW.NREMPENHO;
                  ELSE
                     raise_application_error(-20501, 'SALDO_INSU', True);
                  END IF;
               END IF;
            END IF;
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ATUSALDO_EMPPED','5.05.015'); END;
/
