/*
 Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na
              tabela MENUGRUPOP
 Objetivo: Gerar um log que vai registrar as alteraes na tabela MENUGRUPOP, utilizando
             a tabela Geral de Logs de Operaes */

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_GER_MENUGRUPOP' AND
                 TYPE   = 'TR'                 AND
	              U.UID  = O.UID                AND
	              U.NAME = USER)
DROP TRIGGER LOG_GER_MENUGRUPOP
GO


CREATE TRIGGER LOG_GER_MENUGRUPOP
ON MENUGRUPOP
FOR INSERT, UPDATE, DELETE
AS

   DECLARE  @V_USUARIO      VARCHAR(40);
   DECLARE  @V_TIPO         VARCHAR(1);
   DECLARE  @V_ITPESQ       VARCHAR(40);
   DECLARE  @V_DESC         VARCHAR(300);
   DECLARE  @V_DTOPER       DATETIME;

/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE @V_ID_COMANDO          VARCHAR(1);
   DECLARE @V_OLD_CDGRUPOPER      VARCHAR(2);
   DECLARE @V_OLD_CDSISTGRUP      VARCHAR(10);
   DECLARE @V_OLD_CDMENUITGRUP    VARCHAR(20);
   DECLARE @V_OLD_DSCAPTIONGRU    VARCHAR(80);
   DECLARE @V_OLD_DSBPLGRUP       VARCHAR(10);
   DECLARE @V_OLD_NRTPMENUGRUP    DOUBLE PRECISION;
   DECLARE @V_OLD_NRATALHOGRUP    DOUBLE PRECISION;
   DECLARE @V_OLD_NRNIVELGRUP     DOUBLE PRECISION;
   DECLARE @V_OLD_NRPOSBOTGRUP    DOUBLE PRECISION;
   DECLARE @V_OLD_NRMENUGRGRUP    DOUBLE PRECISION;
   DECLARE @V_NEW_CDGRUPOPER      VARCHAR(2);
   DECLARE @V_NEW_CDSISTGRUP      VARCHAR(10);
   DECLARE @V_NEW_CDMENUITGRUP    VARCHAR(20);
   DECLARE @V_NEW_DSCAPTIONGRU    VARCHAR(80);
   DECLARE @V_NEW_DSBPLGRUP       VARCHAR(10);
   DECLARE @V_NEW_NRTPMENUGRUP    DOUBLE PRECISION;
   DECLARE @V_NEW_NRATALHOGRUP    DOUBLE PRECISION;
   DECLARE @V_NEW_NRNIVELGRUP     DOUBLE PRECISION;
   DECLARE @V_NEW_NRPOSBOTGRUP    DOUBLE PRECISION;
   DECLARE @V_NEW_NRMENUGRGRUP    DOUBLE PRECISION;

BEGIN
   SET @V_TIPO = '0';
   SET @V_DESC = '';
   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT
     'D' IDCOMANDO,
         CDGRUPOPER,
         CDSISTGRUP,
         CDMENUITGRUP,
         DSCAPTIONGRU,
         DSBPLGRUP,
         NRTPMENUGRUP,
         NRATALHOGRUP,
         NRNIVELGRUP,
         NRPOSBOTGRUP,
         NRMENUGRGRUP,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL
   FROM
      DELETED
   WHERE
      CDGRUPOPER NOT IN (SELECT CDGRUPOPER FROM INSERTED)
   UNION ALL
   SELECT
     'U' IDCOMANDO,
         DELETED.CDGRUPOPER,
         DELETED.CDSISTGRUP,
         DELETED.CDMENUITGRUP,
         DELETED.DSCAPTIONGRU,
         DELETED.DSBPLGRUP,
         DELETED.NRTPMENUGRUP,
         DELETED.NRATALHOGRUP,
         DELETED.NRNIVELGRUP,
         DELETED.NRPOSBOTGRUP,
         DELETED.NRMENUGRGRUP,
         INSERTED.CDGRUPOPER,
         INSERTED.CDSISTGRUP,
         INSERTED.CDMENUITGRUP,
         INSERTED.DSCAPTIONGRU,
         INSERTED.DSBPLGRUP,
         INSERTED.NRTPMENUGRUP,
         INSERTED.NRATALHOGRUP,
         INSERTED.NRNIVELGRUP,
         INSERTED.NRPOSBOTGRUP,
         INSERTED.NRMENUGRGRUP
   FROM
      INSERTED,
      DELETED
   WHERE
      INSERTED.CDGRUPOPER = DELETED.CDGRUPOPER

   UNION ALL

   SELECT
     'I' IDCOMANDO,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         CDGRUPOPER,
         CDSISTGRUP,
         CDMENUITGRUP,
         DSCAPTIONGRU,
         DSBPLGRUP,
         NRTPMENUGRUP,
         NRATALHOGRUP,
         NRNIVELGRUP,
         NRPOSBOTGRUP,
         NRMENUGRGRUP
   FROM
      INSERTED
   WHERE
      CDGRUPOPER NOT IN (SELECT CDGRUPOPER FROM DELETED);

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_OLD_CDGRUPOPER,
                                 @V_OLD_CDSISTGRUP,
                                 @V_OLD_CDMENUITGRUP,
                                 @V_OLD_DSCAPTIONGRU,
                                 @V_OLD_DSBPLGRUP,
                                 @V_OLD_NRTPMENUGRUP,
                                 @V_OLD_NRATALHOGRUP,
                                 @V_OLD_NRNIVELGRUP,
                                 @V_OLD_NRPOSBOTGRUP,
                                 @V_OLD_NRMENUGRGRUP,
                                 @V_NEW_CDGRUPOPER,
                                 @V_NEW_CDSISTGRUP,
                                 @V_NEW_CDMENUITGRUP,
                                 @V_NEW_DSCAPTIONGRU,
                                 @V_NEW_DSBPLGRUP,
                                 @V_NEW_NRTPMENUGRUP,
                                 @V_NEW_NRATALHOGRUP,
                                 @V_NEW_NRNIVELGRUP ,
                                 @V_NEW_NRPOSBOTGRUP,
                                 @V_NEW_NRMENUGRGRUP;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'D' BEGIN
         SET @V_TIPO         = '3';
         SET @V_ITPESQ       = @V_OLD_CDGRUPOPER+@V_OLD_CDSISTGRUP+@V_OLD_CDMENUITGRUP;
         IF @V_OLD_CDGRUPOPER IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Oper=' + @V_OLD_CDGRUPOPER;
         END;

         IF @V_OLD_CDSISTGRUP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' SisOper=' + @V_OLD_CDSISTGRUP;
         END;

         IF @V_OLD_CDMENUITGRUP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' MnItOper=' + @V_OLD_CDMENUITGRUP;
         END;

         IF @V_OLD_DSCAPTIONGRU IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DsCaptOper=' + @V_OLD_DSCAPTIONGRU;
         END;

         IF @V_OLD_DSBPLGRUP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DSBPLGRUP=' + @V_OLD_DSBPLGRUP;
         END;

         IF @V_OLD_NRTPMENUGRUP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' TpMenuOper=' + CONVERT(VARCHAR,@V_OLD_NRTPMENUGRUP);
         END;

         IF @V_OLD_NRATALHOGRUP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' AtaOper=' + CONVERT(VARCHAR,@V_OLD_NRATALHOGRUP);
         END;

         IF @V_OLD_NRNIVELGRUP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' NivOper=' + CONVERT(VARCHAR,@V_OLD_NRNIVELGRUP);
         END;

         IF @V_OLD_NRPOSBOTGRUP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' PosBotOper=' + CONVERT(VARCHAR,@V_OLD_NRPOSBOTGRUP);
         END;

         IF @V_OLD_NRMENUGRGRUP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' NrMenu=' + CONVERT(VARCHAR,@V_OLD_NRMENUGRGRUP);
         END;
      END
      ELSE
      IF @V_ID_COMANDO= 'U' /*UPDATING*/ BEGIN
        IF (ISNULL(@V_OLD_CDGRUPOPER,'')   <> ISNULL(@V_NEW_CDGRUPOPER,''))   OR
           (ISNULL(@V_OLD_CDSISTGRUP,'')   <> ISNULL(@V_NEW_CDSISTGRUP,''))   OR
           (ISNULL(@V_OLD_CDMENUITGRUP,'') <> ISNULL(@V_NEW_CDMENUITGRUP,'')) OR
           (ISNULL(@V_OLD_DSCAPTIONGRU,'') <> ISNULL(@V_NEW_DSCAPTIONGRU,'')) OR
           (ISNULL(@V_OLD_DSBPLGRUP,'')    <> ISNULL(@V_NEW_DSBPLGRUP,''))    OR
           (ISNULL(@V_OLD_NRTPMENUGRUP,'') <> ISNULL(@V_NEW_NRTPMENUGRUP,'')) OR
           (ISNULL(@V_OLD_NRATALHOGRUP,'') <> ISNULL(@V_NEW_NRATALHOGRUP,'')) OR
           (ISNULL(@V_OLD_NRNIVELGRUP,'')  <> ISNULL(@V_NEW_NRNIVELGRUP,''))  OR
           (ISNULL(@V_OLD_NRPOSBOTGRUP,'') <> ISNULL(@V_NEW_NRPOSBOTGRUP,'')) OR
           (ISNULL(@V_OLD_NRMENUGRGRUP,'') <> ISNULL(@V_NEW_NRMENUGRGRUP,'')) BEGIN
              SET @V_TIPO         = '2';
              SET @V_ITPESQ       = @V_NEW_CDGRUPOPER+@V_NEW_CDSISTGRUP+@V_NEW_CDMENUITGRUP;
        END;
      END
      ELSE BEGIN
         SET @V_TIPO         = '1';
         SET @V_ITPESQ       = @V_NEW_CDGRUPOPER+@V_NEW_CDSISTGRUP+@V_NEW_CDMENUITGRUP;
      END;
      IF (ISNULL(@V_OLD_CDGRUPOPER,'')   <> ISNULL(@V_NEW_CDGRUPOPER,'')) BEGIN
          SET @V_DESC = @V_DESC + 'Oper='        + @V_NEW_CDGRUPOPER;
      END;
      IF (ISNULL(@V_OLD_CDSISTGRUP,'')   <> ISNULL(@V_NEW_CDSISTGRUP,''))  BEGIN
          SET @V_DESC = @V_DESC + ' SisOper='    + @V_NEW_CDSISTGRUP;
      END;
      IF(ISNULL(@V_OLD_CDMENUITGRUP,'') <> ISNULL(@V_NEW_CDMENUITGRUP,''))  BEGIN
        SET @V_DESC = @V_DESC + ' MnItOper='   + @V_NEW_CDMENUITGRUP;
      END;
      IF(ISNULL(@V_OLD_DSCAPTIONGRU,'') <> ISNULL(@V_NEW_DSCAPTIONGRU,'')) BEGIN
        SET @V_DESC = @V_DESC + ' DsCaptOper=' + @V_NEW_DSCAPTIONGRU;
      END;
      IF(ISNULL(@V_OLD_DSBPLGRUP,'')    <> ISNULL(@V_NEW_DSBPLGRUP,''))    BEGIN
        SET @V_DESC = @V_DESC + ' DSBPLGRUP='  + @V_NEW_DSBPLGRUP;
      END;
      IF(ISNULL(@V_OLD_NRTPMENUGRUP,'') <> ISNULL(@V_NEW_NRTPMENUGRUP,'')) BEGIN
        SET @V_DESC = @V_DESC + ' TpMenuOper=' + CONVERT(VARCHAR,@V_NEW_NRTPMENUGRUP);
      END;
      IF(ISNULL(@V_OLD_NRATALHOGRUP,'') <> ISNULL(@V_NEW_NRATALHOGRUP,''))BEGIN
         SET @V_DESC = @V_DESC + ' AtaOper='    + CONVERT(VARCHAR,@V_NEW_NRATALHOGRUP);
      END;
      IF(ISNULL(@V_OLD_NRNIVELGRUP,'')  <> ISNULL(@V_NEW_NRNIVELGRUP,''))  BEGIN
        SET @V_DESC = @V_DESC + ' NivOper='    + CONVERT(VARCHAR,@V_NEW_NRNIVELGRUP);
      END;
      IF(ISNULL(@V_OLD_NRPOSBOTGRUP,'') <> ISNULL(@V_NEW_NRPOSBOTGRUP,'')) BEGIN
        SET @V_DESC = @V_DESC + ' PosBotOper=' + CONVERT(VARCHAR,@V_NEW_NRPOSBOTGRUP);
      END;
      IF(ISNULL(@V_OLD_NRMENUGRGRUP,'') <> ISNULL(@V_NEW_NRMENUGRGRUP,'')) BEGIN
        SET @V_DESC = @V_DESC + ' NrMenu='     + CONVERT(VARCHAR,@V_NEW_NRMENUGRGRUP);
      END;
      IF @V_TIPO <> '0' BEGIN
         EXEC NMUSUARIO @V_USUARIO;
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();
               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER,
                   IDTIPOOPER, CDPESQITEM, DSOPERACAO)
               VALUES
                  ('MENUGRUPOP',  @V_DTOPER, @V_USUARIO,
                   @V_TIPO,      @V_ITPESQ, @V_DESC);
            END;
         END;
      END;


      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                    @V_OLD_CDGRUPOPER,
                                    @V_OLD_CDSISTGRUP,
                                    @V_OLD_CDMENUITGRUP,
                                    @V_OLD_DSCAPTIONGRU,
                                    @V_OLD_DSBPLGRUP,
                                    @V_OLD_NRTPMENUGRUP,
                                    @V_OLD_NRATALHOGRUP,
                                    @V_OLD_NRNIVELGRUP,
                                    @V_OLD_NRPOSBOTGRUP,
                                    @V_OLD_NRMENUGRGRUP,
                                    @V_NEW_CDGRUPOPER,
                                    @V_NEW_CDSISTGRUP,
                                    @V_NEW_CDMENUITGRUP,
                                    @V_NEW_DSCAPTIONGRU,
                                    @V_NEW_DSBPLGRUP,
                                    @V_NEW_NRTPMENUGRUP,
                                    @V_NEW_NRATALHOGRUP,
                                    @V_NEW_NRNIVELGRUP ,
                                    @V_NEW_NRPOSBOTGRUP,
                                    @V_NEW_NRMENUGRGRUP;


   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_GER_MENUGRUPOP','4.11.105';
GO

