/* Sistemas Integrados TEKNISA

Nome: 6701_ORESTPS_COMPOSICAO_PRODUTO_ORCA.sql

Descrio:
   Retorna o valor da composio do produto.

Criao:
  23/10/2009 Diego Gonalves
*/
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'COMPOSICAO_PRODUTO_ORCA' AND
                 TYPE = 'FN' 		                   AND
	              U.UID = O.UID                      AND
	              U.NAME = USER)
DROP FUNCTION COMPOSICAO_PRODUTO_ORCA
GO

CREATE FUNCTION COMPOSICAO_PRODUTO_ORCA(@P_CDFILIAL         VARCHAR(4),
                                        @P_CDPRODUTO        VARCHAR(10),
                                        @P_CDTPCUSTO        NUMERIC,
                                        @P_QTPRODUTO        DOUBLE PRECISION,
                                        @P_IDVERIFCALC      VARCHAR(1),
                                        @P_DATAATUAL        DATETIME)RETURNS FLOAT
AS
BEGIN
   DECLARE @V_VRCOMPCUSTO     FLOAT;
   DECLARE @V_VRCUSTO         FLOAT;
   DECLARE @V_COTLOCAL        DOUBLE PRECISION;
   DECLARE @V_COTPADRAO       DOUBLE PRECISION;
   DECLARE @V_CDALMOX         VARCHAR(6);
   DECLARE @V_CDLOCAL         VARCHAR(6);
   DECLARE @V_CDPRODUTO       VARCHAR(10);
   DECLARE @V_CDSUBPRODLOC    VARCHAR(10);
   DECLARE @V_QTSUBPRODLOC    DOUBLE PRECISION;
   DECLARE @V_CDSUBPRODUTO    VARCHAR(10);
   DECLARE @V_QTSUBPRODROT    DOUBLE PRECISION;
   DECLARE @V_IDUTILLOTE      VARCHAR(1);
   DECLARE @V_NRLOTEESTQ      VARCHAR(20);
   DECLARE @V_NRSUBLOTE       VARCHAR(4);   
END
GO

ALTER FUNCTION COMPOSICAO_PRODUTO_ORCA(@P_CDFILIAL         VARCHAR(4),
                                       @P_CDPRODUTO        VARCHAR(10),
                                       @P_CDTPCUSTO        NUMERIC,
                                       @P_QTPRODUTO        DOUBLE PRECISION,
                                       @P_IDVERIFCALC      VARCHAR(1),
                                       @P_DATAATUAL        DATETIME)RETURNS FLOAT
AS
BEGIN
   DECLARE @V_VRCOMPCUSTO     FLOAT;
   DECLARE @V_VRCUSTO         FLOAT;
   DECLARE @V_COTLOCAL        DOUBLE PRECISION;
   DECLARE @V_COTPADRAO       DOUBLE PRECISION;
   DECLARE @V_CDALMOX         VARCHAR(6);
   DECLARE @V_CDLOCAL         VARCHAR(6);
   DECLARE @V_CDPRODUTO       VARCHAR(10);
   DECLARE @V_CDSUBPRODLOC    VARCHAR(10);
   DECLARE @V_QTSUBPRODLOC    DOUBLE PRECISION;
   DECLARE @V_CDSUBPRODUTO    VARCHAR(10);
   DECLARE @V_QTSUBPRODROT    DOUBLE PRECISION;
   DECLARE @V_IDUTILLOTE      VARCHAR(1);
   DECLARE @V_NRLOTEESTQ      VARCHAR(20);
   DECLARE @V_NRSUBLOTE       VARCHAR(4);   

   SET @V_VRCUSTO     = 0;
   SET @V_VRCOMPCUSTO = 0;
   SET @V_IDUTILLOTE  = '';
   SET @V_NRLOTEESTQ  = ' ';
   SET @V_NRSUBLOTE   = ' ';   

   /*Este parmetro serve para verificar se a funo retorna o calculo ou se ir inserir produtos.
   Este parmetro somente ser usando no [Lanamento do oramento('C')] e na [execuo do oramento('G')]*/
   IF @P_IDVERIFCALC = 'C' BEGIN
      /*Verifica se existe composio Local para o produto informado.*/
      SELECT @V_COTLOCAL = COUNT(*)
        FROM ROTFABLOCAL R
       WHERE (R.CDFILIAL  = @P_CDFILIAL )
         AND (R.CDPRODUTO = @P_CDPRODUTO);

      IF @V_COTLOCAL > 0 BEGIN
         /* Composio Local */
         DECLARE C_COMPLOCAL CURSOR FOR
         SELECT R.CDPRODUTO, R.CDSUBPRODLOC, R.QTSUBPRODLOC
            FROM ROTFABLOCAL R
           WHERE (R.CDFILIAL  = @P_CDFILIAL )
             AND (R.CDPRODUTO = @P_CDPRODUTO)
           ORDER BY R.NRSEQPRODLOC;
         OPEN C_COMPLOCAL;
         FETCH NEXT FROM C_COMPLOCAL INTO @V_CDPRODUTO, @V_CDSUBPRODLOC, @V_QTSUBPRODLOC;

         WHILE (@@FETCH_STATUS = 0) BEGIN
            SET @V_VRCOMPCUSTO = TEKNISA.COMPOSICAO_PRODUTO_ORCA(@P_CDFILIAL, @V_CDSUBPRODLOC, @P_CDTPCUSTO,
                                                                 @V_QTSUBPRODLOC, @P_IDVERIFCALC,@P_DATAATUAL);

            SET @V_VRCUSTO     = @V_VRCUSTO + (@V_VRCOMPCUSTO * @P_QTPRODUTO);
            FETCH NEXT FROM C_COMPLOCAL INTO @V_CDPRODUTO, @V_CDSUBPRODLOC, @V_QTSUBPRODLOC;
         END;
         CLOSE C_COMPLOCAL;
         DEALLOCATE C_COMPLOCAL;
      END
      ELSE BEGIN
         /*Verifica se existe composio Padro para o produto informado.*/
         SELECT @V_COTPADRAO = COUNT(*)
           FROM ROTFABRICA R
          WHERE (R.CDPRODUTO    = @P_CDPRODUTO);

         IF @V_COTPADRAO > 0 BEGIN
            /*Composio Padro*/
            DECLARE C_COMPPADRAO CURSOR FOR
            SELECT R.CDPRODUTO, R.CDSUBPRODUTO, R.QTSUBPRODROT
               FROM ROTFABRICA R
              WHERE (R.CDPRODUTO    = @P_CDPRODUTO)
              ORDER BY R.CDPRODUTO;
            OPEN C_COMPPADRAO;
            FETCH NEXT FROM C_COMPPADRAO INTO @V_CDPRODUTO, @V_CDSUBPRODUTO, @V_QTSUBPRODROT;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               SET @V_VRCOMPCUSTO = TEKNISA.COMPOSICAO_PRODUTO_ORCA(@P_CDFILIAL, @V_CDSUBPRODUTO, @P_CDTPCUSTO,
                                                                    @V_QTSUBPRODROT, @P_IDVERIFCALC, @P_DATAATUAL);

               SET @V_VRCUSTO     = @V_VRCUSTO + (@V_VRCOMPCUSTO * @P_QTPRODUTO);
               FETCH NEXT FROM C_COMPPADRAO INTO @V_CDPRODUTO, @V_CDSUBPRODUTO, @V_QTSUBPRODROT;
            END;
            CLOSE C_COMPPADRAO;
            DEALLOCATE C_COMPPADRAO;
         END
         ELSE BEGIN
            
            SELECT @V_IDUTILLOTE = IDUTILLOTE               
              FROM PARAMFILIAL 
             WHERE CDFILIAL = @P_CDFILIAL;

            IF @V_IDUTILLOTE = 'N' BEGIN  
                /*Pega os produtos sem composio e passa o valor do custo para o mesmo.*/
                SELECT DISTINCT @V_CDALMOX = CASE PA.IDUTILALMOX WHEN 'S' THEN ISNULL(PF.CDALMOXPRCLI, PA.CDALMOXARIFE) ELSE ' ' END,
                                @V_CDLOCAL = CASE PA.IDUTILLCESTQ WHEN 'S' THEN ISNULL(PF.CDLOCALPRCLI, PA.CDLOCALESTOQ) ELSE ' ' END
                  FROM PRODFILI PF, PARAMFILIAL PA, PRODUTO PR, DEPARTAMENTO DE
                 WHERE PA.CDFILIAL     = @P_CDFILIAL
                   AND PR.CDPRODUTO    = @P_CDPRODUTO
                   AND PR.CDDEPTPEDORC = DE.CDDEPTO
                   AND PA.CDFILIAL     = DE.CDFILIPEDORC
                   AND PF.CDPRODUTO    = PR.CDPRODUTO
                   AND PA.CDFILIAL     = PF.CDFILIAL;

                SET @V_VRCUSTO = TEKNISA.CUSTO_PRODUTO_LCEST(@P_CDFILIAL, @P_CDPRODUTO, @P_CDTPCUSTO,
                                                             @P_DATAATUAL, @P_DATAATUAL, @V_CDALMOX, @V_CDLOCAL, '', '');

                RETURN(@V_VRCUSTO * @P_QTPRODUTO);
            END
            ELSE BEGIN

                SELECT DISTINCT @V_CDALMOX = CASE PA.IDUTILALMOX WHEN 'S' THEN ISNULL(PF.CDALMOXPRCLI, PA.CDALMOXARIFE) ELSE ' ' END,
                                @V_CDLOCAL = CASE PA.IDUTILLCESTQ WHEN 'S' THEN ISNULL(PF.CDLOCALPRCLI, PA.CDLOCALESTOQ) ELSE ' ' END
               
                  FROM PRODFILI PF, PARAMFILIAL PA, PRODUTO PR, DEPARTAMENTO DE
                 WHERE PA.CDFILIAL     = @P_CDFILIAL
                   AND PR.CDPRODUTO    = @P_CDPRODUTO
                   AND PR.CDDEPTPEDORC = DE.CDDEPTO
                   AND PA.CDFILIAL     = DE.CDFILIPEDORC
                   AND PF.CDPRODUTO    = PR.CDPRODUTO
                   AND PA.CDFILIAL     = PF.CDFILIAL;      
              
                SELECT @V_NRLOTEESTQ = MAX(NRLOTEESTQ), @V_NRSUBLOTE = MAX(NRSUBLOTE)
                  FROM POSESTDIA
                 WHERE CDFILIAL      = @P_CDFILIAL
                   AND CDPRODUTO     = @P_CDPRODUTO
                   AND CDALMOXARIFE  = @V_CDALMOX
                   AND CDLOCALESTOQ  = @V_CDLOCAL
                   AND DTPOSIESTQ    <= (SELECT MAX(P.DTPOSIESTQ) DTPOSIESTQ
                                           FROM POSESTDIA P
                                          WHERE P.CDFILIAL     = @P_CDFILIAL
                                            AND P.CDPRODUTO    = @P_CDPRODUTO
                                            AND P.CDALMOXARIFE = @V_CDALMOX
                                            AND P.CDLOCALESTOQ = @V_CDLOCAL
                                            AND P.DTPOSIESTQ   <= @P_DATAATUAL+1)
                   AND NRLOTEESTQ    =  (SELECT MAX(NRLOTEESTQ) NRLOTEESTQ
                                           FROM POSESTDIA P
                                          WHERE P.CDFILIAL     = @P_CDFILIAL
                                            AND P.CDPRODUTO    = @P_CDPRODUTO
                                            AND P.CDALMOXARIFE = @V_CDALMOX
                                            AND P.CDLOCALESTOQ = @V_CDLOCAL
                                            AND P.DTPOSIESTQ   <= @P_DATAATUAL+1);
              
                SET @V_VRCUSTO = TEKNISA.CUSTO_PRODUTO_LCEST(@P_CDFILIAL, @P_CDPRODUTO, @P_CDTPCUSTO, @P_DATAATUAL, @P_DATAATUAL,
                                                             @V_CDALMOX, @V_CDLOCAL, @V_NRLOTEESTQ, @V_NRSUBLOTE);
                RETURN (@V_VRCUSTO * @P_QTPRODUTO);
            END;
         END;
      END;
   END;
   RETURN(@V_VRCUSTO);
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'COMPOSICAO_PRODUTO_ORCA','5.07.000';
GO